<?php

namespace FiloBlu\OrderAdditionalData\Controller\Adminhtml\Order;

use Magento\Backend\App\Action;
use Magento\Framework\Controller\Result\JsonFactory;
use Magento\Framework\Controller\ResultInterface;
use Magento\Sales\Api\OrderRepositoryInterface;

/**
 * Class Save
 * @package FiloBlu\OrderAdditionalData\Controller\Order
 */
class Save extends Action
{
    /**
     * @var JsonFactory
     */
    private $jsonFactory;

    /**
     * @var OrderRepositoryInterface
     */
    private $orderRepository;

    /**
     * Save constructor.
     * @param Action\Context $context
     * @param OrderRepositoryInterface $orderRepository
     * @param JsonFactory $jsonFactory
     */
    public function __construct(
        Action\Context $context,
        OrderRepositoryInterface $orderRepository,
        JsonFactory $jsonFactory
    ) {
        parent::__construct($context);
        $this->jsonFactory = $jsonFactory;
        $this->orderRepository = $orderRepository;
    }

    /**
     * @return ResultInterface
     */
    public function execute()
    {
        $orderId = $this->getRequest()->getParam('id', null);

        if ($orderId) {
            $order = $this->orderRepository->get($orderId);

            $data = $this->getRequest()->getParam('filoblu_additional_data', []);
            foreach ($data as $name => $value) {
                $order->setData($name, $value);
            }

            $this->orderRepository->save($order);
        }

        return $this->jsonFactory->create()->setData([]);
    }
}
